<?php
/*
    Uploadify
    Copyright (c) 2012 Reactive Apps, Ronnie Garcia
    Released under the MIT License <http://www.opensource.org/licenses/mit-license.php>

    -----------

     
      http://mvoc.ru
    : Skriptoff
    skype: Skriptoff
    icq: 3503584

*/

include('../../inc_common.php');
include($engine_path . 'users_get_list.php');
include($file_path . "inc_user_class.php");
include($ld_engine_path . "users_get_object.php");
include('functions.php');



if (file_exists($data_path . 'mvoc/attachments/config.dat')) {
    $fc = file_get_contents($data_path . 'mvoc/attachments/config.dat');
    $config = parse_dat($fc);
} else {
    echo 'config';
    exit;
}

if (!$config['on']) {
    exit;
}
if ($current_user->online_time < $config['point_limit'] && !$cu_array[USER_CLASS]) {
    exit;
}
if ($cu_array[USER_CLASS]) {
    $config['max_all_size'] = $config['admin_max_all_size'];
}

if (!$exists || !$is_regist) {
    $error_text = "$w_no_user";
    include($file_path . 'designes/' . $design . '/error_page.php');
    exit;
}

/* file path */
$upload_path = $file_path . 'mvoc/attachments/upload/' . (int) ($is_regist / 1000) . '/';
if ( ! file_exists($upload_path)) {
    @chmod($file_path . 'mvoc/attachments/upload/', 0777);
    @mkdir($upload_path);
    @chmod($upload_path, 0777);
}
$upload_path .= $is_regist . '/';
if ( ! file_exists($upload_path)) {
    @mkdir($upload_path);
    @chmod($upload_path, 0777);
}

/* data path */
if ( ! file_exists($data_path . 'mvoc/')) {
    @mkdir($data_path . 'mvoc/');
    @chmod($data_path . 'mvoc/', 0777);
}
if ( ! file_exists($data_path . 'mvoc/attachments/')) {
    @mkdir($data_path . 'mvoc/attachments/');
    @chmod($data_path . 'mvoc/attachments/', 0777);
}
$mvoc_data_path = $data_path . 'mvoc/attachments/' . (int) ($is_regist / 1000) . '/';
if ( ! file_exists($mvoc_data_path)) {
    @mkdir($mvoc_data_path);
    @chmod($mvoc_data_path);
}

$fileTypes = array('jpg', 'jpeg', 'gif', 'png', 'mp3');
$verifyToken = md5($config['salt'] . $_POST['timestamp']);
$user_path = $file_path . 'mvoc/attachments/upload/' . (int) ($is_regist / 1000) . '/' . $is_regist . '/';
$size = 0;
$count_images = 0;
$count_musics = 0;

if (!empty($_FILES) && $_POST['token'] == $verifyToken) {

    foreach (new DirectoryIterator($user_path) as $del ) {
        if ($del->isDot()) continue;

        $size += $del->getSize();

        if (strtolower(pathinfo($del->getFilename(), PATHINFO_EXTENSION)) == 'mp3') {
            $count_musics++;
        } else if (in_array(strtolower(pathinfo($del->getFilename(), PATHINFO_EXTENSION)), $fileTypes)) {
            $count_images++;
        } else {
            @unlink($del->getPathname());
            continue;
        }
    }

    if (($_FILES['Filedata']['size'] + $size)  > (($config['max_all_size'] * 1024 * 1024))) {
        echo 'max_size';
        exit;
    }

	$tempFile = $_FILES['Filedata']['tmp_name'];

	$fileParts = pathinfo($_FILES['Filedata']['name']);

	if (in_array(strtolower($fileParts['extension']), $fileTypes)) {
        if ($fileParts['extension'] == 'mp3' && $config['musics']) {
            if ($_FILES['Filedata']['size'] > ($config['limit_music_size'] * 1024 * 1024)) {
                echo 'size';
                exit;
            }
            if ($count_musics > $config['limit_musics']) {
                echo 'limit';
                exit;
            }

            $filename = uniqid() . rand(0,1000);
            $targetFile = rtrim($upload_path, '/') . '/' . $filename . '.mp3';
            move_uploaded_file($tempFile, $targetFile);

            $music_file = $mvoc_data_path . $is_regist . '_music.dat';
            if ( ! file_exists($music_file)) {
                $data = array($filename => strip_tags(htmlspecialchars($_FILES['Filedata']['name'])));
            } else {
                $data = unserialize(file_get_contents($music_file));
                $data[$filename] = iconv("UTF-8", "windows-1251", strip_tags(htmlspecialchars($_FILES['Filedata']['name'])));
            }

            $data = serialize($data);
            save_file($music_file, $data, 'w');
            print json_encode(array('name' => $filename, 'title' => strip_tags(htmlspecialchars($_FILES['Filedata']['name']))));
            exit;
        } else if ($config['images']){
            if ($_FILES['Filedata']['size'] > ($config['limit_image_size'] * 1024 * 1024)) {
                echo 'size';
                exit;
            }
            if ($count_images > $config['limit_images']) {
                echo 'limit';
                exit;
            }

            $file = uniqid() . rand(0,1000) . '.' . strtolower($fileParts['extension']);
            $targetFile = rtrim($upload_path, '/') . '/' . $file;
            move_uploaded_file($tempFile, $targetFile);
            print json_encode(array('name' => $file));
            exit;
        }

	} else {
		echo 'type';
	}
}